/*
**
****************************************************************************
**
**
**             쌠 (c) 2007 - Atmel Corporation
**             L
**
** 		: ATMEGA88+ATA6832 
** Pʕ	: Hall_sensors.h
** 		: BLDCd@
**            ΰيmݕω荞݂Ə
**
**  :  		  t: : :
** 1.0   2007N124  F.G.  쐬
**
** LICENSE -
**
** ATMEL - 2007
** SĂ̿ĳ ۸т͔@Ȃۏ؂Ȃu󂻂̂܂܁vŒ񋟂܂B
** Atmel͔@ȂړIɑ΂Ă񋟂̓K𖾌܂Bَ̕
** ؁A̖ړIւ̓KAAyєNQ܂݁A񋟂ĳɊւS
** Ă̕ۏ؂ƏAtmel͂Ŕ۔F܂BAtmelͿĳ ۸ׂ̎g
** ̔@ȂԐړI܂͌ʂƂĐ鑹Q܂@Ȃ鑹Qɑ΂ĂӔC
** ܂B
****************************************************************************
**
*/

#ifndef HALL_SENSOR_H
#define HALL_SENSOR_H

/*_____ ݸٰ ____________________________________________________________*/

/*_____ ϸ ________________________________________________________________*/

/*_____ ` _______________________________________________________________*/

#define HALL_MASK		(_HALL_A | _HALL_B | _HALL_C)	//<! ߰CłΰيmՕɗLp
#define HALL_A_MASK		_HALL_A							//<! ΰيmAՕ
#define HALL_B_MASK		_HALL_B							//<! ΰيmBՕ
#define HALL_C_MASK		_HALL_C							//<! ΰيmCՕ

#define MOTOR_CW		0
#define MOTOR_CCW		1

typedef enum
{
	MOTOR_STATUS_STOPPED,
	MOTOR_STATUS_START_CW,
	MOTOR_STATUS_CW,
	MOTOR_STATUS_START_CCW,
	MOTOR_STATUS_CCW
} Motor_ctrl_t;

/*_____ ^錾 ___________________________________________________________*/

void Hall_sensors_ISR_init(void);
Motor_ctrl_t BLDC_start(unsigned char direction);

/*_____ Sϐ ___________________________________________________________*/

extern const unsigned int H_bridge_CW_cmd[];
extern const unsigned int H_bridge_CCW_cmd[];

#endif //HALL_SENSOR_H
