/*
**
****************************************************************************
**
**
**             쌠 (c) 2007 - Atmel Corporation
**             L
**
** 		: ATMEGA88+ATA6832 
** Pʕ	: High_temp_main.c
** 		: BLDCd@
**            "BLDC"Ƃł̎gp̂
**
**  :  		  t: : :
** 1.0   2007N123  F.G.  쐬
**
** LICENSE -
**
** ATMEL - 2007
** SĂ̿ĳ ۸т͔@Ȃۏ؂Ȃu󂻂̂܂܁vŒ񋟂܂B
** Atmel͔@ȂړIɑ΂Ă񋟂̓K𖾌܂Bَ̕
** ؁A̖ړIւ̓KAAyєNQ܂݁A񋟂ĳɊւS
** Ă̕ۏ؂ƏAtmel͂Ŕ۔F܂BAtmelͿĳ ۸ׂ̎g
** ̔@ȂԐړI܂͌ʂƂĐ鑹Q܂@Ȃ鑹Qɑ΂ĂӔC
** ܂B
****************************************************************************
**
*/

/*_____ ݸٰ ____________________________________________________________*/

#include "config.h"
#include "SPI_interface.h"
#include "ADC_task.h"
#include "ATA6832_defs.h"
#include "Hall_sensors.h"
#include "Timer1_PWM.h"


/*_____ ϸ ________________________________________________________________*/

/*_____ ` _______________________________________________________________*/

/*_____ ^錾 ___________________________________________________________*/

/*_____ Sϐ ___________________________________________________________*/

/**
 * @fn main
 *
 **/

void main(void)
{
	Motor_ctrl_t motor_status = MOTOR_STATUS_STOPPED;
	SPI_status_t SPI_status;
	U16 speed =0;

	CLKPR   = 0x80;
	CLKPR   = 0x00;					//  ۯOuȂ
	CONFIG_IO_PORTS();				// I/O߰č\ݒ
	SET_GREEN_LED();

	/* ATmega88Ӌ@\ */
	SPI_MasterInit();				// @2MHzSPI
	ADC_Init();						// ADC̎Jn
	Hall_sensors_ISR_init();		// ݕω荞ݏ
	Timer1_start();					// PWMpvJn
	__enable_interrupt();

	/* ATA6832 */
	ata6832_cmd.bit.si = false;		// ATA6832ĳ֎~
	ata6832_cmd.bit.srr = true;		// ُ׸ ؾ
	SPI_transmit_16(ata6832_cmd.value);

	while(1)
	{
		// (v1׸ނg)ԊǗ
		manage_time_base();

		// SPI̓ްATA6832lXV
		SPI_get_Rx_data(&ata6832_status.value);

		// (ADC)Speed_set͂ɏ]PWMݒ
		TIMER1_SET_OC1A_PWM(speed>>1);	// 9ޯĕ\

		/* d@Ǘ */
		switch(motor_status)
		{
			//--------------------------------------------------------------------
			case MOTOR_STATUS_STOPPED:						// d@͒~
				if (GET_SWITCH_CW())						// ؂ւ킩CWsߎ擾
				{
					motor_status = BLDC_start(MOTOR_CW);	// ̈ʒuɏ]ēd@Jn
				}
				else if (GET_SWITCH_CCW())					// ؂ւ킩CCWsߎ擾
				{
					motor_status = BLDC_start(MOTOR_CCW);	// ̈ʒuɏ]ēd@Jn
				}
				else										// ؂ւ킩̖߂Ȃ
				{	// ATA6832ɑ΂ČpIް𑗎M
					SPI_status = SPI_transmit_16(ata6832_cmd.value);
				}
				break;

			//--------------------------------------------------------------------
			case MOTOR_STATUS_START_CW:
			case MOTOR_STATUS_CW:							// d@͎vős
				if (!GET_SWITCH_CW() && !GET_SWITCH_CCW())	// d@~
					motor_status = MOTOR_STATUS_STOPPED;
				break;

			//--------------------------------------------------------------------
			case MOTOR_STATUS_START_CCW:
			case MOTOR_STATUS_CCW:							// d@͔vős
				if (!GET_SWITCH_CW() && !GET_SWITCH_CCW())	// d@~
					motor_status = MOTOR_STATUS_STOPPED;
				break;

			//--------------------------------------------------------------------
			default:
				ata6832_cmd.value = 0x00;
				ata6832_cmd.bit.si = false;					// ATA6832ĳ֎~
				ata6832_cmd.bit.srr = true;					// ُ׸ ؾ
				SPI_transmit_16(ata6832_cmd.value);
				SET_GREEN_LED();
				motor_status = MOTOR_STATUS_STOPPED;
				break;
		}

		/* ffAATA6831/ATA6832ް-ĎQ */
		if (  (ata6832_status.bit.tp == true)				// xOx
			||(ata6832_status.bit.ovl == true)				// Œ1̏o͂OFF(ߕ)
			||(ata6832_status.bit.psf == true))				// Vs݂ł̒d
		{
			// xOx̏ꍇ̑x
			if (ata6832_status.bit.tp == true)				// xOXȂA
			{												// d@x
				if (get_speed() > 255)
					speed = 255;							// ő25%ɑ萧
				else
					speed = get_speed();
			}
			else
				speed = get_speed();

			// ̕\
			if (time_count_1s.ovf == true)
			{
				TOGGLE_GREEN_LED();							// LEDݐ؂ւɂ̍}
				time_count_1s.ovf =false;
			}

			// ̉
			if (!GET_SWITCH_CW() && !GET_SWITCH_CCW())
			{												// ؂ւ킪~ɏQ
				ata6832_cmd.value = 0x00;
				ata6832_cmd.bit.si = false;					// ATA6832ĳ֎~
				ata6832_cmd.bit.srr = true;					// ُ׸ ؾ
			}
		}
		else
		{
			SET_GREEN_LED();								// ʏ퓮
			speed = get_speed();
		}
	}
}
