/*
**
****************************************************************************
**
**
**             쌠 (c) 2007 - Atmel Corporation
**             L
**
** 		: ATMEGA88+ATA6832 
** Pʕ	: ATA6832_defs.h
** 		: BLDCd@
**            AT6832ɂĎg閽߂ƏԂ̍\̒`
**
**  :  		  t: : :
** 1.0   2007N124  F.G.  쐬
**
** LICENSE -
**
** ATMEL - 2007
** SĂ̿ĳ ۸т͔@Ȃۏ؂Ȃu󂻂̂܂܁vŒ񋟂܂B
** Atmel͔@ȂړIɑ΂Ă񋟂̓K𖾌܂Bَ̕
** ؁A̖ړIւ̓KAAyєNQ܂݁A񋟂ĳɊւS
** Ă̕ۏ؂ƏAtmel͂Ŕ۔F܂BAtmelͿĳ ۸ׂ̎g
** ̔@ȂԐړI܂͌ʂƂĐ鑹Q܂@Ȃ鑹Qɑ΂ĂӔC
** ܂B
****************************************************************************
**
*/
#ifndef ATA6832_DEFS_H
#define ATA6832_DEFS_H

/*_____ ݸٰ ____________________________________________________________*/

/*_____ ϸ ________________________________________________________________*/

/*_____ ` _______________________________________________________________*/

//! @defgroup ATA6832_command_register
//! ڼ޽̈`
//! @{

//! ATA6832_cmd_stATA6832ڼ޽̊ëڏq܂B
typedef struct 
{
	unsigned int srr  :1;	//!< ڼ޽ ؾ		: H=APSF&OVLޯĂؾ
	unsigned int ls1  :1;	//!< LS1o͐		: H=LS1oON
	unsigned int hs1  :1;	//!< HS1o͐		: H=HS1oON
	unsigned int ls2  :1;	//!< LS2o͐		: H=LS2oON
	unsigned int hs2  :1;	//!< HS2o͐		: H=HS2oON
	unsigned int ls3  :1;	//!< LS3o͐		: H=LS3oON
	unsigned int hs3  :1;	//!< HS3o͐		: H=HS3oON
	unsigned int pl1  :1;	//!< PWM͂ɂĒǉ䂳LS1o
	unsigned int ph1  :1;	//!< PWM͂ɂĒǉ䂳HS1o
	unsigned int pl2  :1;	//!< PWM͂ɂĒǉ䂳LS2o
	unsigned int ph2  :1;	//!< PWM͂ɂĒǉ䂳HS2o
	unsigned int pl3  :1;	//!< PWM͂ɂĒǉ䂳LS3o
	unsigned int ph3  :1;	//!< PWM͂ɂĒǉ䂳HS3o
	unsigned int old  :1;	//!< J׌o		: L=ON
	unsigned int ocs  :1;	//!< ߓd~			: H=OCS
	unsigned int si   :1;	//!< ĳ֎~			: L=޲AH=ʏ퓮
} ATA6832_cmd_st;

//! ATA6832_cmd_tATA6832߂ɏՂĂ̑S̈eՂɱ̂Ɏg܂B
typedef union
{
	unsigned int value;
	ATA6832_cmd_st bit;
} ATA6832_cmd_t;

/* ڼ޽̈l` */
#define SRR		0x0001		//!< ڼ޽ ؾ
#define LS1		0x0002		//!< LS1o͐
#define HS1		0x0004		//!< HS1o͐
#define LS2		0x0008		//!< LS2o͐
#define HS2		0x0010		//!< HS2o͐
#define LS3		0x0020		//!< LS3o͐
#define HS3		0x0040		//!< HS3o͐
#define PL1		0x0080		//!< PWM͂ɂĒǉ䂳LS1o
#define PH1		0x0100		//!< PWM͂ɂĒǉ䂳HS1o
#define PL2		0x0200		//!< PWM͂ɂĒǉ䂳LS2o
#define PH2		0x0400		//!< PWM͂ɂĒǉ䂳HS2o
#define PL3		0x0800		//!< PWM͂ɂĒǉ䂳LS3o
#define PH3		0x1000		//!< PWM͂ɂĒǉ䂳HS3o
#define OLD		0x2000		//!< J׌o
#define OCS		0x4000		//!< ߓd~
#define SI		0x8000		//!< ĳ֎~
//! @}

//! @defgroup ATA6832_status_register
//! ڼ޽̈`
//! @{

//! ATA6832_status_stATA6832ڼ޽̊ëڏq܂B
typedef struct 
{
	unsigned int	tp			:1;		//!< xOx : H=x
	unsigned int	ls1_status	:1;		//!< LS1 : H=oONAL=oOFF J : H=JׁAL=JׂȂ
	unsigned int	hs1_status	:1;		//!< LS1Q
	unsigned int	ls2_status	:1;		//!< LS1Q
	unsigned int	hs2_status	:1;		//!< LS1Q
	unsigned int	ls3_status	:1;		//!< LS1Q
	unsigned int	hs3_status	:1;		//!< LS1Q
	unsigned int	spare		:6;		//!< (sgp)
	unsigned int	ovl			:1;		//!< ߕ׌o : H=HZ܂͉xߎۂɂčŒ1̏o͂OFFɐ؂ւꂽB
	unsigned int	inh			:1;		//!< ĳ֎~ : H=޲AL=ʏ퓮
	unsigned int	psf			:1;		//!< dQ : H=Vs݂Œd
} ATA6832_status_st;

//! ATA6832_status_tATA6832ڼ޽ɏՂĂ̑S̈eՂɱ̂Ɏg܂B
typedef union
{
	unsigned int value;			//!< 16ޯ ڼ޽e̒ړIȊi[܂B
	ATA6832_status_st bit;		//!< eڼ޽ ޯĂ̓Ɨ܂B
} ATA6832_status_t;

/* ڼ޽̈l` */
#define	TP			0x0001		//!< xOx
#define	LS1_STATUS	0x0002		//!< LS1
#define	HS1_STATUS	0x0004		//!< HS1
#define	LS2_STATUS	0x0008		//!< LS2
#define	HS2_STATUS	0x0010		//!< HS2
#define	LS3_STATUS	0x0020		//!< LS3
#define	HS3_STATUS	0x0040		//!< HS3
#define SPARE		0x1F80		//!< (sgp)
#define OVL			0x2000		//!< ߕ׌o
#define INH			0x4000		//!< ĳ֎~
#define PSF			0x8000		//!< dQ
//! @}

/*_____ ^錾 ___________________________________________________________*/

/*_____ Sϐ ___________________________________________________________*/

extern ATA6832_cmd_t       ata6832_cmd;		//!< ڼ޽ɑATA6832
extern ATA6832_status_t    ata6832_status;	//!< MATA6832ڼ޽l

#endif // ATA6832_DEFS_H
